class ThreadGroupTest {
  public static void main(String[] args) {
    ThreadGroup grandpa = new ThreadGroup("grandpa");
    ThreadGroup daddy = new ThreadGroup(grandpa,"daddy");
    ThreadGroup child = new ThreadGroup(daddy, "child");

    test(grandpa, grandpa);
    test(grandpa, daddy);
    test(grandpa, child);

    test(daddy, grandpa);
    test(daddy, daddy);
    test(daddy, child);

    test(child, grandpa);
    test(child, daddy);
    test(child, child);

    try {
	test(grandpa, null);
	test(daddy, null);
	test(child, null);
    } catch(NullPointerException e) {
	System.out.println("Caught NullPointerException");
    }
  }

    static void test(ThreadGroup g1, ThreadGroup g2) {
	System.out.println(g1.getName() + "," + g2.getName() + ": "
			   + g1.parentOf(g2));
    }
}

/* Expected Output:
grandpa,grandpa: true
grandpa,daddy: true
grandpa,child: true
daddy,grandpa: false
daddy,daddy: true
daddy,child: true
child,grandpa: false
child,daddy: false
child,child: true
Caught NullPointerException
*/
